﻿Imports System.Data

Public Module ModuleDC

    Private bInit As Boolean=False
    Private WithEvents _dcDoc As MediaCy.Addins.DataCollector.McDataCollectorDocument

    Public ReadOnly Property dcDoc As MediaCy.Addins.DataCollector.McDataCollectorDocument
        Get
            If _dcDoc Is Nothing Then
                _dcDoc=MediaCy.Addins.DataCollector.McDataCollectorAddin.ThisAddin.Document
            End If
            Return _dcDoc
        End Get
    End Property

    Public Function CollectDataMacro() As SimpleScript
        CollectDataMacro = New SimpleScript

        With Measure.Data.CollectorCommands.Collect(CollectDataMacro)
            .Run(Nothing)
        End With

    End Function

    Public Sub AddField(tableName As String, columnName As String, columnType As System.Type)
        Dim ds As DataSet =dcDoc.SelectedDataSet
        Dim dt As DataTable=ds.Tables(tableName)
        If dt Is Nothing Then
            'add new table
            dt=ds.Tables.Add(tableName)
        End If
        If dt.Columns.Contains(columnName) Then Exit Sub 'already added

        'add it
        With Measure.Data.Collector.MeasurementsCommands.Add(Nothing)
            .TableName = tableName
            .DataType = columnType
            .ColumnName = columnName
            .Visible = True
            .Action = MediaCy.Addins.DataCollector.eAction.AddNew
            .Run()
        End With
    End Sub

    Public Sub SetDataToLastRow(tableName As String, columnName As String, value As Object)
        Dim ds As DataSet =dcDoc.Data
        Dim dt As DataTable=ds.Tables(tableName)
        If dt Is Nothing Then Exit Sub

        If dt.Rows.Count=0 Then Exit Sub
        If Not dt.Columns.Contains(columnName) Then
            MsgBox("Column " & columnName & " doesn't exist")
            Exit Sub
        End If

        Dim dr As DataRow=dt.Rows(dt.Rows.Count-1)
        Try
            dr.Item(columnName)=value
        Catch
            MsgBox("Error setting value")
        Finally
        End Try
    End Sub

        Public Sub SetDataToNewRow(tableName As String, columnName As String, value As Object)
        Dim ds As DataSet =dcDoc.Data
        Dim dt As DataTable=ds.Tables(tableName)
        If dt Is Nothing Then Exit Sub

        If Not dt.Columns.Contains(columnName) Then
            MsgBox("Column " & columnName & " doesn't exist")
            Exit Sub
        End If

        Try
            Dim dr As DataRow=dt.NewRow()
            dr.Item(columnName)=value
            dt.Rows.Add(dr)
        Catch
            MsgBox("Error setting value")
        Finally
        End Try
    End Sub

    Public Sub RefreshStats
        Dim cm As New MediaCy.Addins.DataCollector.DataCollectorCommand()
        Dim tbl As MediaCy.Addins.DataCollector.McDataCollectorTable=cm.GetDataTable(False)
        If tbl IsNot Nothing AndAlso tbl.ShowStats Then
            tbl.RefreshView
        End If
    End Sub

    Public Sub AddDCFiels()
        'AddField("MyNewTable","ExperimentName",GetType (System.String))'activate this line to add column in a NEW table
        AddField("Image","ExperimentName",GetType (System.String))
        AddField("Image","ExperimentDescription",GetType (System.String))
        AddField("Image","ExperimentValue",GetType (System.Double))
    End Sub

    Public Sub CollectData(expName As String,expDescription As String, value As Double)
        CollectDataMacro
        'SetDataToNewRow("MyNewTable","ExperimentName",expName)'activate this line to add data to a new table
        SetDataToLastRow("Image","ExperimentName",expName)
        SetDataToLastRow("Image","ExperimentDescription",expDescription)
        SetDataToLastRow("Image","ExperimentValue",value)

        RefreshStats
    End Sub
End Module
